.\" Copyright (c) 1999 Andries Brouwer (aeb@cwi.nl)
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one
.\" 
.\" Since the Linux kernel and libraries are constantly changing, this
.\" manual page may be incorrect or out-of-date.  The author(s) assume no
.\" responsibility for errors or omissions, or for damages resulting from
.\" the use of the information contained herein.  The author(s) may not
.\" have taken the same level of care in the production of this manual,
.\" which is licensed free of charge, as they might when working
.\" professionally.
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\"
.TH TMPNAM 3  "14 June 1999" "" "Linux Programmer's Manual"
.SH NAME
tmpnam \- create a name for a temporary file
.SH SYNOPSIS
.nf
.B #include <stdio.h>
.sp
.BI "char *tmpnam(char *" s );
.fi
.SH DESCRIPTION
The
.B tmpnam()
function returns a pointer to a string that is a valid filename,
and such that a file with this name did not exist at some point
in time, so that naive programmers may think it
a suitable name for a temporary file. If the argument
.I s
is NULL this name is generated in an internal static buffer
and may be overwritten by the next call to
.BR tmpnam() .
If
.I s
is not NULL, the name is copied to the character array (of length
at least
.IR L_tmpnam )
pointed at by
.I s
and the value
.I s
is returned in case of success.
.LP
The path name that is created, has a directory prefix
.IR P_tmpdir .
(Both
.I L_tmpnam
and
.I P_tmpdir
are defined in
.IR <stdio.h> ,
just like the TMP_MAX mentioned below.)
.SH "RETURN VALUE"
The
.B tmpnam()
function returns a pointer to a unique temporary 
filename, or NULL if a unique name cannot be generated.
.SH ERRORS
No errors are defined.
.SH NOTES
Portable applications that use threads cannot call
.B tmpnam()
with NULL parameter if either
_POSIX_THREAD_SAFE_FUNCTIONS or _POSIX_THREADS is defined.
.LP
The
.B tmpnam()
function generates a different string each time it is called,
up to TMP_MAX times. If it is called more than TMP_MAX times,
the behaviour is implementation defined.
.SH BUGS
Never use this function. Use
.BR mkstemp (3)
instead.
.SH "CONFORMING TO"
SVID 2, POSIX, BSD 4.3, ISO 9899
.SH "SEE ALSO"
.BR mktemp (3),
.BR mkstemp (3),
.BR tempnam (3),
.BR tmpfile (3)
